ents-button.has-icon.has-text svg {
  margin-right: 8px;
}
.components-button.has-icon.has-text .dashicon {
  margin-right: 10px;
}
.components-button.is-pressed {
  color: #fff;
  background: #1e1e1e;
}
.components-button.is-pressed:focus:not(:disabled) {
  box-shadow: inset 0 0 0 1px #fff, 0 0 0 var(--wp-admin-border-width-focus) var(--wp-admin-theme-color);
  outline: 2px solid transparent;
}
.components-button.is-pressed:hover:not(:disabled) {
  color: #fff;
  background: #1e1e1e;
}
.components-button svg {
  fill: currentColor;
  outline: none;
}
.components-button .components-visually-hidden {
  height: auto;
}

@-webkit-keyframes components-button__busy-animation {
  0% {
    background-position: 200px 0;
  }
}

@keyframes components-button__busy-animation {
  0% {
    background-position: 200px 0;
  }
}
.components-checkbox-control__input[type=checkbox] {
  font-family: -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, Oxygen-Sans, Ubuntu, Cantarell, "Helvetica Neue", sans-serif;
  padding: 6px 8px;
  box-shadow: 0 0 0 transparent;
  transition: box-shadow 0.1s linear;
  border-radius: 2px;
  border: 1px solid #757575;
  /* Fonts smaller than 16px causes mobile safari to zoom. */
  font-size: 16px;
  /* Override core line-height. To be reviewed. */
  line-height: normal;
  border: 1px solid #1e1e1e;
  margin-right: 12px;
  transition: none;
  border-radius: 2px;
  background: #fff;
  color: #1e1e1e;
  clear: none;
  cursor: pointer;
  display: inline-block;
  line-height: 0;
  margin: 0 4px 0 0;
  outline: 0;
  padding: 0 !important;
  text-align: center;
  vertical-align: top;
  width: 24px;
  height: 24px;
  -webkit-appearance: none;
          appearance: none;
  transition: 0.1s border-color ease-in-out;
}
@media (prefers-reduced-motion: reduce) {
  .components-checkbox-control__input[type=checkbox] {
    transition-duration: 0s;
    transition-delay: 0s;
  }
}
@media (min-width: 600px) {
  .components-checkbox-control__input[type=checkbox] {
    font-size: 13px;
    /* Override core line-height. To be reviewed. */
    line-height: normal;
  }
}
.components-checkbox-control__input[type=checkbox]:focus {
  border-color: var(--wp-admin-theme-color);
  box-shadow: 0 0 0 1px var(--wp-admin-theme-color);
  outline: 2px solid transparent;
}
.components-checkbox-control__input[type=checkbox]::-webkit-input-placeholder {
  color: rgba(30, 30, 30, 0.62);
}
.components-checkbox-control__input[type=checkbox]::-moz-placeholder {
  opacity: 1;
  color: rgba(30, 30, 30, 0.62);
}
.components-checkbox-control__input[type=checkbox]:-ms-input-placeholder {
  color: rgba(30, 30, 30, 0.62);
}
.components-checkbox-control__input[type=checkbox]:focus {
  box-shadow: 0 0 0 2px #fff, 0 0 0 4px var(--wp-admin-theme-color);
  outline: 2px solid transparent;
}
.components-checkbox-control__input[type=checkbox]:checked {
  background: var(--wp-admin-theme-color);
  border-color: var(--wp-admin-theme-color);
}
.components-checkbox-control__input[type=checkbox]:checked::-ms-check {
  opacity: 0;
}
.components-checkbox-control__input[type=checkbox]:checked::before, .components-checkbox-control__input[type=checkbox][aria-checked=mixed]::before {
  margin: -3px -5px;
  color: #fff;
}
@media (min-width: 782px) {
  .components-checkbox-control__input[type=checkbox]:checked::before, .components-checkbox-control__input[type=checkbox][aria-checked=mixed]::before {
    margin: -4px 0 0 -5px;
  }
}
.components-checkbox-control__input[type=checkbox][aria-checked=mixed] {
  background: var(--wp-admin-theme-color);
  border-color: var(--wp-admin-theme-color);
}
.components-checkbox-control__input[type=checkbox][aria-checked=mixed]::before {
  content: "";
  float: left;
  display: inline-block;
  vertical-align: middle;
  width: 16px;
  /* stylelint-disable */
  font: normal 30px/1 dashicons;
  /* stylelint-enable */
  speak: none;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}
@media (min-width: 782px) {
  .components-checkbox-control__input[type=checkbox][aria-checked=mixed]::before {
    float: none;
    font-size: 21px;
  }
}
@media (min-width: 600px) {
  .components-checkbox-control__input[type=checkbox] {
    height: 20px;
    width: 20px;
  }
}
@media (prefers-reduced-motion: reduce) {
  .components-checkbox-control__input[type=checkbox] {
    transition-duration: 0s;
    transition-delay: 0s;
  }
}
.components-checkbox-control__input[type=checkbox]:focus {
  box-shadow: 0 0 0 2px #fff, 0 0 0 4px var(--wp-admin-theme-color);
  outline: 2px solid transparent;
}
.components-checkbox-control__input[type=checkbox]:checked {
  background: var(--wp-admin-theme-color);
  border-color: var(--wp-admin-theme-color);
}
.components-checkbox-control__input[type=checkbox]:checked::-ms-check {
  opacity: 0;
}
.components-checkbox-control__input[type=checkbox]:checked::before {
  content: none;
}

.components-checkbox-control__input-container {
  position: relative;
  display: inline-block;
  margin-right: 12px;
  vertical-align: middle;
  width: 24px;
  height: 24px;
}
@media (min-width: 600px) {
  .components-checkbox-control__input-container {
    width: 20px;
    height: 20px;
  }
}

svg.components-checkbox-control__checked {
  fill: #fff;
  cursor: pointer;
  position: absolute;
  left: 0;
  top: 0;
  width: 24px;
  height: 24px;
  -webkit-user-select: none;
          user-select: none;
  pointer-events: none;
}
@media (min-width: 600px) {
  svg.components-checkbox-control__checked {
    left: -2px;
    top: -2px;
  }
}

.components-circular-option-picker {
  display: inline-block;
  width: 100%;
  min-width: 188px;
}
.components-circular-option-picker .components-circular-option-picker__custom-clear-wrapper {
  display: flex;
  justify-content: flex-end;
}
.components-circular-option-picker .components-circular-option-picker__swatches {
  margin-right: -12px;
}

.components-circular-option-picker__option-wrapper {
  display: inline-block;
  height: 28px;
  width: 28px;
  margin-right: 12px;
  margin-bottom: 12px;
  vertical-align: top;
  -webkit-transform: scale(1);
          transform: scale(1);
  transition: 100ms -webkit-transform ease;
  transition: 100ms transform ease;
  transition: 100ms transform ease, 100ms -webkit-transform ease;
}
@media (prefers-reduced-motion: reduce) {
  .components-circular-option-picker__option-wrapper {
    transition-duration: 0s;
    transition-delay: 0s;
  }
}
.components-circular-option-picker__option-wrapper:hover {
  -webkit-transform: scale(1.2);
          transform: scale(1.2);
}
.components-circular-option-picker__option-wrapper > div {
  height: 100%;
  width: 100%;
}

.components-circular-option-picker__option-wrapper::before {
  content: "";
  position: absolute;
  top: 1px;
  left: 1px;
  bottom: 1px;
  right: 1px;
  border-radius: 50%;
  z-index: -1;
  /* stylelint-disable-next-line function-url-quotes */
  background: url('data:image/svg+xml,%3Csvg width="28" height="28" fill="none" xmlns="http://www.w3.org/2000/svg"%3E%3Cpath d="M6 8V6H4v2h2zM8 8V6h2v2H8zM10 16H8v-2h2v2zM12 16v-2h2v2h-2zM12 18v-2h-2v2H8v2h2v-2h2zM14 18v2h-2v-2h2zM16 18h-2v-2h2v2z" fill="%23555D65"/%3E%3Cpath fill-rule="evenodd" clip-rule="evenodd" d="M18 18h2v-2h-2v-2h2v-2h-2v-2h2V8h-2v2h-2V8h-2v2h2v2h-2v2h2v2h2v2zm-2-4v-2h2v2h-2z" fill="%23555D65"/%3E%3Cpath d="M18 18v2h-2v-2h2z" fill="%23555D65"/%3E%3Cpath fill-rule="evenodd" clip-rule="evenodd" d="M8 10V8H6v2H4v2h2v2H4v2h2v2H4v2h2v2H4v2h2v-2h2v2h2v-2h2v2h2v-2h2v2h2v-2h2v2h2v-2h2v-2h-2v-2h2v-2h-2v-2h2v-2h-2v-2h2V8h-2V6h2V4h-2v2h-2V4h-2v2h-2V4h-2v2h-2V4h-2v2h2v2h-2v2H8zm0 2v-2H6v2h2zm2 0v-2h2v2h-2zm0 2v-2H8v2H6v2h2v2H6v2h2v2h2v-2h2v2h2v-2h2v2h2v-2h2v2h2v-2h-2v-2h2v-2h-2v-2h2v-2h-2v-2h2V8h-2V6h-2v2h-2V6h-2v2h-2v2h2v2h-2v2h-2z" fill="%23555D65"/%3E%3Cpath fill-rule="evenodd" clip-rule="evenodd" d="M4 0H2v2H0v2h2v2H0v2h2v2H0v2h2v2H0v2h2v2H0v2h2v2H0v2h2v2H0v2h2v-2h2v2h2v-2h2v2h2v-2h2v2h2v-2h2v2h2v-2h2v2h2v-2h2v2h2v-2h2v-2h-2v-2h2v-2h-2v-2h2v-2h-2v-2h2v-2h-2v-2h2V8h-2V6h2V4h-2V2h2V0h-2v2h-2V0h-2v2h-2V0h-2v2h-2V0h-2v2h-2V0h-2v2H8V0H6v2H4V0zm0 4V2H2v2h2zm2 0V2h2v2H6zm0 2V4H4v2H2v2h2v2H2v2h2v2H2v2h2v2H2v2h2v2H2v2h2v2h2v-2h2v2h2v-2h2v2h2v-2h2v2h2v-2h2v2h2v-2h2v2h2v-2h-2v-2h2v-2h-2v-2h2v-2h-2v-2h2v-2h-2v-2h2V8h-2V6h2V4h-2V2h-2v2h-2V2h-2v2h-2V2h-2v2h-2V2h-2v2H8v2H6z" fill="%23555D65"/%3E%3C/svg%3E');
}

.components-circular-option-picker__option {
  display: inline-block;
  vertical-align: top;
  height: 100%;
  width: 100%;
  border: none;
  border-radius: 50%;
  background: transparent;
  box-shadow: inset 0 0 0 14px;
  transition: 100ms box-shadow ease;
  cursor: pointer;
}
@media (prefers-reduced-motion: reduce) {
  .components-circular-option-picker__option {
    transition-duration: 0s;
    transition-delay: 0s;
  }
}
.components-circular-option-p