 [setup a nonce](https://developer.wordpress.org/block-editor/reference-guides/packages/packages-api-fetch/#built-in-middlewares) correctly,
	 * and the logged in user has the appropriate permissions.
	 *
	 * ```
	 * wp.apiFetch( {
	 *      path: '/font-awesome/v1/api',
	 *      method: 'POST',
	 *      body: 'query { release(version: "5.x") { version } }'
	 *  } ).then( res => {
	 *      console.log( res );
	 *  } )
	 * ```
	 *
	 * Or you could issue your own `POST` request directly `api.fontawesome.com`.
	 * [See the Font Awesome GraphQL API reference here](https://fontawesome.com/v5.15/how-to-use/graphql-api/intro/getting-started).
	 *
	 * @since 4.0.0
	 * @deprecated
	 *
	 * @return null|string
	 */
	public function latest_version() {
		return $this->release_provider()->latest_version();
	}

	/**
	 * Returns the latest available full release version of Font Awesome 5 as a string,
	 * or null if the releases metadata has not yet been successfully retrieved from the
	 * API server.
	 *
	 * @since 4.2.0
	 *
	 * @return null|string
	 */
	public function latest_version_5() {
		return $this->release_provider()->latest_version_5();
	}

	/**
	 * Returns the latest available full release version of Font Awesome 6 as a string,
	 * or null if the releases metadata has not yet been successfully retrieved from the
	 * API server.
	 *
	 * @since 4.2.0
	 *
	 * @return null|string
	 */
	public function latest_version_6() {
		return $this->release_provider()->latest_version_6();
	}

	/**
	 * Queries the Font Awesome API to load releases metadata. Results are stored
	 * in the wp database.
	 *
	 * This is the metadata that supports API
	 * methods like {@see FontAwesome::latest_version()}
	 * and all other metadata required to enqueue Font Awesome when configured
	 * to use the standa