S_WPCOM )
		|| Jetpack::is_connection_ready()
	) {
		Blocks::jetpack_register_block(
			BLOCK_NAME,
			array(
				'render_callback' => __NAMESPACE__ . '\load_assets',
				'supports'        => array(
					'align'   => array( 'wide', 'full' ),
					'color'   => array(
						'gradients' => true,
					),
					'spacing' => array(
						'padding' => true,
						'margin'  => true,
					),
				),
			)
		);
	}
}
add_action( 'init', __NAMESPACE__ . '\register_block' );

/**
 * Mailchimp block registration/dependency declaration.
 *
 * @param array  $attr - Array containing the Mailchimp block attributes.
 * @param string $content - Mailchimp block content.
 *
 * @return string
 */
function load_assets( $attr, $content ) {

	if ( ! verify_connection() ) {
		return null;
	}

	$values  = get_attributes_with_defaults( $attr );
	$blog_id = ( defined( 'IS_WPCOM' ) && IS_WPCOM )
		? get_current_blog_id()
		: Jetpack_Options::get_option( 'id' );
	Jetpack_Gutenberg::load_assets_as_required( FEATURE_NAME );
	$wrapper_attributes = \WP_Block_Supports::get_instance()->apply_block_supports();
	$classes            = ! empty( $wrapper_attributes['class'] ) ? $wrapper_attributes['class'] : '';
	$amp_form_action    = sprintf( 'https://public-api.wordpress.com/rest/v1.1/sites/%s/email_follow/amp/subscribe/', $blog_id );
	$is_amp_request     = Blocks::is_amp_request();

	ob_start();
	?>

	<div class="<?php echo esc_attr( $classes ); ?>"<?php echo ! empty( $wrapper_attributes['style'] ) ? ' style="' . esc_attr( $wrapper_attributes['style'] ) . '"' : ''; ?> data-blog-id="<?php echo esc_attr( $blog_id ); ?>">
		<form
			aria-describedby="wp-block-jetpack-mailchimp_consent-text"
			<?php if ( $is_amp_request ) : ?>
				action-xhr="<?php echo esc_url( $amp_form_action ); ?>"
				method="post"
				id="mailchimp_form"
				target="_top"
				on="submit-success:AMP.setState( { mailing_list_status: 'subscribed', mailing_list_email: event.response.email } )"
			<?php endif; ?>
		>
			<p>
				<input
					aria-label="<?php echo esc_attr( $values['emailPlaceholder'] ); ?>"
					placeholder="<?php echo esc_attr( $values['emailPlaceholder'] ); ?>"
					required
					title="<?php echo esc_attr( $values['emailPlaceholder'] ); ?>"
					type="email"
					name="email"
				/>
			</p>
			<?php foreach ( is_array( $values['interests'] ) ? $values['interests'] : array() as $interest ) : ?>
				<input
					name="interests[<?php echo esc_attr( $interest ); ?>]"
					type="hidden"
					class="mc-submit-param"
					value="1"
				/>
			<?php endforeach; ?>
			<?php
			if (
				! empty( $values['signupFieldTag'] )
				&& ! empty( $values['signupFieldValue'] )
				) :
				?>
				<in