 New markup block button class before rendering here.
		if ( false === strpos( $content, 'wp-block-jetpack-button' ) ) {
			$content = deprecated_render_button_v1( $attr, $block_id, $classes, $url );
		} else {
			$content = str_replace( 'calendly-widget-id', esc_attr( $block_id ), $content );
			$content = str_replace( $base_url, $url, $content );
		}

		if ( ! $is_amp_request ) {
			wp_add_inline_script(
				'jetpack-calendly-external-js',
				sprintf( "calendly_attach_link_events( '%s' )", esc_js( $block_id ) )
			);
		}
	} else { // Inline style.
		if ( $is_amp_request ) {
			$content = sprintf(
				'<div class="%1$s" id="%2$s"><a href="%3$s" role="button" target="_blank">%4$s</a></div>',
				esc_attr( Blocks::classes( FEATURE_NAME, $attr ) ),
				esc_attr( $block_id ),
				esc_js( $url ),
				wp_kses_post( get_attribute( $attr, 'submitButtonText' ) )
			);
		} else {
			$content = sprintf(
				'<div class="%1$s" id="%2$s"></div>',
				esc_attr( $classes ),
				esc_attr( $block_id )
			);
			$script  = <<<JS_END
jetpackInitCalendly( '%s', '%s' );
JS_END;
			wp_add_inline_script( 'jetpack-calendly-external-js', sprintf( $script, esc_url( $url ), esc_js( $block_id ) ) );
		}
	}

	return $content;
}

/**
 * Get filtered attributes.
 *
 * @param array  $attributes     Array containing the Calendly block attributes.
 * @param string $attribute_name String containing the attribute name to get.
 *
 * @return string
 */
function get_attribute( $attributes, $attribute_name ) {
	if ( isset( $attributes[ $attribute_name ] ) ) {
		return $attributes[ $attribute_name ];
	}

	$default_attributes = array(
		'style'                => 'inline',
		'submitButtonText'     => esc_html__( 'Schedule time with me', 'jetpack' ),
		'backgroundColor'      => 'ffffff',
		'textColor'            => '4D5055',
		'primaryColor'         => '00A2FF',
		'hideEventTypeDetails' => false,
	);

	if ( isset( $default_attributes[ $attribute_name ] ) ) {
		return $default_attributes[ $attribute_name ];
	}
}

/**
 * Enqueues the Calendly JS library and inline function to attach event
 * handlers to the button.
 *
 * @return void
 */
function enqueue_calendly_js() {
	wp_enqueue_script(
		'jetpack-calendly-external-js',
		'https://assets.calendly.com/assets/external/widget.js',
		null,
		JETPACK__VERSION,
		false
	);

	wp_add_inline_script(
		'jetpack-calendly-external-js',
		"function jetpackInitCalendly( url, elementId ) {
			function initCalendlyWidget() {
				if ( ! document.getElementById( elementId ) ) {
					return;
				}
				Calendly.initInlineWidget({
					url: url,
					parentElement: document.getElementById( elementId ),
					inlineStyles: false,
				});
			};
			// For P2s only: wait until after o2 has
			// replaced main#content to initialize widget.
			if ( window.jQuery && window.o2 ) {
				jQuery( 'body' ).on( 'ready_o2', function() { initCalendlyWidget() } );
			// Else initialize widget without waiting.
			} else {
				document.addEventListe