ValidVariableName.VariableNotSnakeCase
 * @phpcs:disable WordPress.NamingConventions.ValidVariableName.PropertyNotSnakeCase
 * @phpcs:disable WordPress.NamingConventions.ValidFunctionName.MethodNameInvalid
 * @phpcs:disable WordPress.Files.FileName
 */

use \Automattic\Jetpack\Device_Detection\User_Agent_Info;

/**
 * A class providing device properties detection.
 *
 * @deprecated 8.7.0 Use Automattic\Jetpack\Device_Detection\User_Agent_Info
 */
class Jetpack_User_Agent_Info {

	/**
	 * User_Agent_Info instance from the `jetpack-device-detection` package.
	 *
	 * @var User_Agent_Info
	 */
	private $ua_info;

	/**
	 * The constructor.
	 *
	 * @param string $ua (Optional) User agent.
	 *
	 * @deprecated 8.7.0 Use Automattic\Jetpack\Device_Detection\User_Agent_Info
	 */
	public function __construct( $ua = '' ) {
		_deprecated_function( __METHOD__, 'Jetpack 8.7', '\Automattic\Jetpack\Device_Detection\User_Agent_Info from the `automattic/jetpack-device-detection` package' );
		$this->ua_info = new User_Agent_Info( $ua );
	}

	/**
	 * This method detects the mobile User Agent name.
	 *
	 * @deprecated 8.7.0 Use Automattic\Jetpack\Device_Detection\User_Agent_Info
	 *
	 * @return string The matched User Agent name, false otherwise.
	 */
	public function get_mobile_user_agent_name() {
		_deprecated_function( __METHOD__, 'Jetpack 8.7', '\Automattic\Jetpack\Device_Detection\User_Agent_Info->get_mobile_user_agent_name from the `automattic/jetpack-device-detection` package' );
		return $this->ua_info->get_mobile_user_agent_name();
	}

	/**
	 * This method detects the mobile device's platform. All return strings are from the class constants.
	 * Note that this function returns the platform name, not the UA name/type. You should use a different function
	 * if you need to test the UA capabilites.
	 *
	 * @deprecated 8.7.0 Use Automattic\Jetpack\Device_Detection\User_Agent_Info
	 *
	 * @return string Name of the platform, false otherwise.
	 */
	public function get_platform() {
		_deprecated_function( __METHOD__, 'Jetpack 8.7', '\Automattic\Jetpack\Device_Detection\User_Agent_Info->get_platform from the `automattic/jetpack-device-detection` package' );
		return $this->ua_info->get_platform();
	}

	/**
	 * This method detects for UA which can display iPhone-optimized web content.
	 * Includes iPhone, iPod Touch, Android, WebOS, Fennec (Firefox mobile), etc.
	 *
	 * @deprecated 8.7.0 Use Automattic\Jetpack\Device_Detection\User_Agent_Info
	 */
	public function isTierIphone() {
		_deprecated_function( __METHOD__, 'Jetpack 8.7', '\Automattic\Jetpack\Device_Detection\User_Agent_Info->isTierIphone from the `automattic/jetpack-device-detection` package' );
		return $this->ua_info->isTierIphone();
	}

	/**
	 * This method detects for UA which are likely to be capable
	 * but may not necessarily support JavaScript.
	 * Excludes all iPhone Tier UA.
	 *
	 * @deprecated 8.7.0 Use Automattic\Jetpack\Device_D