 * that will re-run it if there are items in the queue at the end.
			 */
			if ( 'sync' === $type && $executions >= 1 && Settings::is_dedicated_sync_enabled() ) {
				break;
			}

			$result = 'full_sync' === $type ? self::$sender->do_full_sync() : self::$sender->do_sync();

			// # of send actions performed.
			$executions ++;

		} while ( $result && ! is_wp_error( $result ) && ( $start_time + $time_limit ) > time() );

		return $executions;
	}

	/**
	 * Initialize the sync listener.
	 *
	 * @access public
	 * @static
	 */
	public static function initialize_listener() {
		self::$listener = Listener::get_instance();
	}

	/**
	 * Initializes the sync sender.
	 *
	 * @access public
	 * @static
	 */
	public static function initialize_sender() {
		self::$sender = Sender::get_instance();
		add_filter( 'jetpack_sync_send_data', array( __CLASS__, 'send_data' ), 10, 8 );
	}

	/**
	 * Initializes sync for WooCommerce.
	 *
	 * @access public
	 * @static
	 */
	public static function initialize_woocommerce() {
		if ( false === class_exists( 'WooCommerce' ) ) {
			return;
		}
		add_filter( 'jetpack_sync_modules', array( __CLASS__, 'add_woocommerce_sync_module' ) );
	}

	/**
	 * Initializes sync for Instant Search.
	 *
	 * @access public
	 * @static
	 */
	public static function initialize_search() {
		if ( false === class_exists( 'Automattic\\Jetpack\\Search\\Module_Control' ) ) {
			return;
		}
		$search_module = new \Automattic\Jetpack\Search\Module_Control();
		if ( $search_module->is_instant_search_enabled() ) {
			add_filter( 'jetpack_sync_modules', array( __CLASS__, 'add_search_sync_module' ) );
		}
	}

	/**
	 * Add Search updates to Sync Filters.
	 *
	 * @access public
	 * @static
	 *
	 * @param array $sync_modules The list of sync modules declared prior to this filter.
	 * @return array A list of sync modules that now includes Search's modules.
	 */
	public static function add_search_sync_module( $sync_modules ) {
		$sync_modules[] = 'Automattic\\Jetpack\\Sync\\Modules\\Search';
		return $sync_modules;
	}

	/**
	 * Adds Woo's sync modules to existing modules for sending.
	 *
	 * @access public
	 * @static
	 *
	 * @param array $sync_modules The list of sync modules declared prior to this filter.
	 * @return array A list of sync modules that now includes Woo's modules.
	 */
	public static function add_woocommerce_sync_module( $sync_modules ) {
		$sync_m