 => '(string) The theme slug',
		),
		'request_format'          => array(
			'action'     => '(string) Only possible value is \'update\'. More to follow.',
			'autoupdate' => '(bool) Whether or not to automatically update the theme.',
		),
		'response_format'         => Jetpack_JSON_API_Themes_Endpoint::$_response_format,
		'allow_jetpack_site_auth' => true,
		'example_request_data'    => array(
			'headers' => array(
				'authorization' => 'Bearer YOUR_API_TOKEN',
			),
			'body'    => array(
				'action' => 'update',
			),
		),
		'example_request'         => 'https://public-api.wordpress.com/rest/v1/sites/example.wordpress.org/themes/twentyfourteen',
	)
);

new Jetpack_JSON_API_Themes_Modify_Endpoint(
	array(
		'description'             => 'Modify a list of themes on a jetpack blog',
		'group'                   => '__do_not_document',
		'stat'                    => 'themes:modify',
		'method'                  => 'POST',
		'path'                    => '/sites/%s/themes',
		'path_labels'             => array(
			'$site' => '(int|string) The site ID, The site domain',
		),
		'request_format'          => array(
			'action'     => '(string) Only possible value is \'update\'. More to follow.',
			'autoupdate' => '(bool) Whether or not to automatically update the theme.',
			'themes'     => '(array) A list of theme slugs',
		),
		'response_format'         => array(
			'themes' => '(array:theme) A list of theme objects',
		),
		'allow_jetpack_site_auth' => true,
		'example_request_data'    => array(
			'headers' => array(
				'authorization' => 'Bearer YOUR_API_TOKEN',
			),
			'body'    => array(
				'action' => 'autoupdate_on',
				'themes' => array(
					'twentytwelve',
					'twentyfourteen',
				),
			),
		),
		'example_request'         => 'https://public-api.wordpress.com/rest/v1/sites/example.wordpress.org/themes',
	)
);

require_once $json_jetpack_endpoints_dir . 'class.jetpack-json-api-themes-install-endpoint.php';
// POST /sites/%s/themes/%s/install
new Jetpack_JSON_API_The