      => 'POST',
		'path'                 => '/sites/%s/core',
		'stat'                 => 'core',
		'path_labels'          => array(
			'$site' => '(int|string) The site ID, The site domain',
		),
		'request_format'       => array(
			'autoupdate' => '(bool) Whether or not we automatically update core',
		),
		'response_format'      => array(
			'version'    => '(string) The current version',
			'autoupdate' => '(bool) Whether or not we automatically update core',
		),
		'example_request_data' => array(
			'headers' => array(
				'authorization' => 'Bearer YOUR_API_TOKEN',
			),
			'body'    => array(
				'autoupdate' => true,
			),
		),
		'example_request'      => 'https://public-api.wordpress.com/rest/v1/sites/example.wordpress.org/core',
	)
);

require_once $json_jetpack_endpoints_dir . 'class.jetpack-json-api-sync-endpoint.php';

// POST /sites/%s/sync
new Jetpack_JSON_API_Sync_Endpoint(
	array(
		'description'             => 'Force sync of all options and constants',
		'method'                  => 'POST',
		'path'                    => '/sites/%s/sync',
		'stat'                    => 'sync',
		'allow_jetpack_site_auth' => true,
		'path_labels'             => array(
			'$site' => '(int|string) The site ID, The site domain',
		),
		'request_format'          => array(
			'modules' 