,
		),
		'example_request'         => 'https://public-api.wordpress.com/rest/v1.1/sites/example.wordpress.org/sync/close',
	)
);

require_once $json_jetpack_endpoints_dir . 'class.jetpack-json-api-log-endpoint.php';

new Jetpack_JSON_API_Jetpack_Log_Endpoint(
	array(
		'description'     => 'Get the Jetpack log',
		'method'          => 'GET',
		'path'            => '/sites/%s/jetpack-log',
		'stat'            => 'log',
		'path_labels'     => array(
			'$site' => '(int|string) The site ID, The site domain',
		),
		'request_format'  => array(
			'event' => '(string) The event to filter by, by default all entries are returned',
			'num'   => '(int) The number of entries to get, by default all entries are returned',
		),
		'response_format' => array(
			'log' => '(array) An array of jetpack log entries',
		),
		'example_request' => 'https://public-api.wordpress.com/rest/v1.1/sites/example.wordpress.org/jetpack-log',
	)
);

require_once $json_jetpack_endpoints_dir . 'class.jetpack-json-api-maybe-auto-update-endpoint.php';

new Jetpack_JSON_API_Maybe_Auto_Update_Endpoint(
	array(
		'description'     => 'Maybe Auto Update Core, Plugins, Themes and Languages',
		'method'          => 'POST',
		'path'            => '/sites/%s/maybe-auto-update',
		'stat'            => 'maybe-auto-update',
		'path_labels'     => array(
			'$site' => '(int|string) The site ID, The site domain',
		),
		'response_format' => array(
			'log' => '(array) Results of running the update job',
		),
		'example_request' => 'https://public-api.wordpress.com/rest/v1.1/sites/example.wordpress.org/maybe-auto-update',

	)
);

require_once $json_jetpack_endpoints_dir . 'class.jetpack-json-api-translations-endpoint.php';
require_once $json_jetpack_endpoints_dir . 'class.jetpack-json-api-translations-modify-endpoint.php';

new Jetpack_JSON_API_Translations_Endpoint(
	array(
		'description'          => 'Gets info about a Jetpack blog\'s core installation',
		'method'               => 'GET',
		'path'                 => '/sites/%s/translations',
		'stat'                 => 'translations',
		'path_labels'          => array(
			'$site' => '(int|string) The site ID, The site domain',
		),
		'response_format'      => array(
			'translations' => '(array) A list of translations that are available',
			'autoupdate'   => '(bool) Whether or not we automatically update translations',
			'log'          => '(array:safehtml) An array of log strings.',
		),
		'example_request_data' => array(
			'headers' => array(
				'authorization' => 'Bearer YOUR_API_TOKEN',
			),
		),
		'example_request'      => 'https://public-api.wordpress.com/rest/v1/sites/example.wordpress.org/translations',
	)
);

new Jetpack_JSON_API_Translations_Modify_Endpoint(
	array(
		'description'          => 'Toggle automatic core updates for a Jetpack blog',
		'method'               => 'POST',
		'path'                 => '/sites/%s/translations',
		'stat'                 => 'translations',
		'path_labels'          => array(
			'$site' => '(int|string) The site ID, The site domain',
		),
		'request_format'       => array(
			'autoupdate' => '(bool) Whether or not we automatically update translations',
		),
		'response_format'      => array(
			'translations' => '(array) A list of translations that are available',
			'autoupdate'   => '(bool) Whether or not we automatically update translations',
		),
		'example_request_data' => array(
			'headers' => array(
				'authorization' => 'Bearer YOUR_API_TOKEN',
			),
			'body'    => array(
				'autoupdate' => true,
			),
		),
		'example_request'      => 'https://public-api.wordpress.com/rest/v1/sites/example.wordpress.org/translations',
	)
);

new Jetpack_JSON_API_Translations_Modify_Endpoint(
	array(
		'description'          => 'Update All Translations installation on a Jetpack blog',
		'method'               => 'POST',
		'path'                 => '/sites/%s/translations/update',
		'stat'                 => 'translations:update',
		'path_labels'          => array(
			'$site' => '(int|string) The site ID, The site domain',
		),
		'response_format'      => array(
			'log'     => '(array:safehtml) An array of log strings.',
			'success' => '(bool) Was the operation successful',
		),
		'example_request_data' => array(
			'headers' => array(
				'authorization' => 'Bearer YOUR_API_TOKEN',
			),
		),
		'example_request'      => 'https://public-api.wordpress.com/rest/v1/sites/example.wordpress.org/translations/update',
	)
);

// Options
require_once $json_jetpack_endpoints_dir . 'class.wpcom-json-api-get-option-endpoint.php';

new WPCOM_JSON_API_Get_Option_Endpoint(
	array(
		'method'                  => 'GET',
		'description'             => 'Fetches an option.',
		'group'                   => '__do_not_document',
		'stat'                    => 'option',
		'allow_jetpack_site_auth' => true,
		'path'                    => '/sites/%s/option',
		'path_labels'             => array(
			'$site' => '(int|string) Site ID or domain',
		),
		'query_parameters'        => array(
			'option_name' => '(string) The name of the option to fetch.',
			'site_option' => '(bool=false) True 