   => 'https://public-api.wordpress.com/rest/v1/sites/example.wordpress.org/themes',
	)
);

require_once $json_jetpack_endpoints_dir . 'class.jetpack-json-api-themes-get-endpoint.php';
require_once $json_jetpack_endpoints_dir . 'class.jetpack-json-api-themes-new-endpoint.php';

// POST /sites/%s/themes/%new
new Jetpack_JSON_API_Themes_New_Endpoint(
	array(
		'description'             => 'Install a theme to your jetpack blog',
		'group'                   => '__do_not_document',
		'stat'                    => 'themes:new',
		'method'                  => 'POST',
		'path'                    => '/sites/%s/themes/new',
		'path_labels'             => array(
			'$site' => '(int|string) The site ID, The site domain',
		),
		'request_format'          => array(
			'zip' => '(zip) Theme package zip file. multipart/form-data encoded. ',
		),
		'response_format'         => Jetpack_JSON_API_Themes_Endpoint::$_response_format,
		'allow_jetpack_site_auth' => true,
		'example_request_data'    => array(
			'headers' => array(
				'authorization' => 'Bearer YOUR_API_TOKEN',
			),
		),
		'example_request'         => 'https://public-api.wordpress.com/rest/v1/sites/example.wordpress.org/themes/new',
	)
);

new Jetpack_JSON_API_Themes_Get_Endpoint(
	array(
		'description'             => 'Get a single theme on a jetpack blog',
		'group'                   => '__do_not_document',
		'stat'                    => 'themes:get:1',
		'method'                  => 'GET',
		'path'                    => '/sites/%s/themes/%s',
		'path_labels'             => array(
			'$site'  => '(int|string) The site ID, The site domain',
			'$theme' => '(string) The theme slug',
		),
		'response_format'         => Jetpack_JSON_API_Themes_End