'path_labels'             => array(
			'$site' => '(int|string) The site ID, The site domain',
		),
		'response_format'         => array(
			'modules' => '(array) An array of module objects.',
		),
		'allow_jetpack_site_auth' => true,
		'example_request_data'    => array(
			'headers' => array(
				'authorization' => 'Bearer YOUR_API_TOKEN',
			),
		),
		'example_request'         => 'https://public-api.wordpress.com/rest/v1.2/sites/example.wordpress.org/jetpack/modules',
	)
);

require_once $json_jetpack_endpoints_dir . 'class.jetpack-json-api-updates-status-endpoint.php';

new Jetpack_JSON_API_Updates_Status(
	array(
		'description'          => 'Get counts for available updates',
		'method'               => 'GET',
		'path'                 => '/sites/%s/updates',
		'stat'                 => 'updates',
		'path_labels'          => array(
			'$site' => '(int|string) The site ID, The site domain',
		),
		'response_format'      => array(
			'plugins'           => '(int) The total number of plugins updates.',
			'themes'            => '(int) The total number of themes updates.',
			'wordpress'         => '(int) The total number of core updates.',
			'translations'      => '(int) The total number of translation updates.',
			'total'             => '(int) The total number of updates.',
			'wp_version'        => '(safehtml) The wp_version string.',
			'wp_update_version' => '(safehtml) The wp_version to update string.',
			'jp_version'        => '(safehtml) The site Jetpack version.',
		),
		'example_request_data' => array(
			'headers' => array(
	