am string $hook - the hook.
	 * @param array  $args - the arguments.
	 *
	 * @return array
	 */
	protected function get_schedules( $hook, $args ) {
		$crons = _get_cron_array();
		$key   = md5( serialize( $args ) ); // phpcs:ignore WordPress.PHP.DiscouragedPHPFunctions.serialize_serialize
		if ( empty( $crons ) ) {
			return array();
		}
		$found = array();
		foreach ( $crons as $timestamp => $cron ) {
			if ( isset( $cron[ $hook ][ $key ] ) ) {
				$found[] = $timestamp;
			}
		}

		return $found;
	}

	/**
	 * This function is based on the one found in wp-cron.php with a similar name
	 *
	 * @return int
	 */
	protected function get_cron_lock() {
		global $wpdb;

		$value = 0;
		if ( wp_using_ext_object_cache() ) {
			/*
			 * Skip local cache and force re-fetch of doing_cron transient
			 * in case another process updated the cache.
			 */
			$value = wp_cache_get( 'doing_cron', 'transient', true );
		} else {
			$row = $wpdb->get_row( $wpdb->prepare( "SELECT option_value FROM $wpdb->options WHERE option_name = %s LIMIT 1", '_transient_doing_cron' ) );
			if ( is_object( $row ) ) {
				$value = $row->option_value;
			}
		}
		return $value;
	}
}

/**
 * Cron post endpoint class.
 *
 * POST /sites/%s/cron
 */
class Jetpack_JSON_API_Cron_Post_Endpoint extends Jetpack_JSON_API_Cron_Endpoint { // phpcs:ignore Generic.Fi