ple_request'      => 'https://public-api.wordpress.com/rest/v1/sites/example.wordpress.org/me/capability',
	)
);

// CORE
require_once $json_jetpack_endpoints_dir . 'class.jetpack-json-api-core-endpoint.php';
require_once $json_jetpack_endpoints_dir . 'class.jetpack-json-api-core-modify-endpoint.php';

new Jetpack_JSON_API_Core_Endpoint(
	array(
		'description'          => 'Gets info about a Jetpack blog\'s core installation',
		'method'               => 'GET',
		'path'                 => '/sites/%s/core',
		'stat'                 => 'core',
		'path_labels'          => array(
			'$site' => '(int|string) The site ID, The site domain',
		),
		'response_format'      => array(
			'version'    => '(string) The current version',
			'autoupdate' => '(bool) Whether or not we automatically update core',
		),
		'example_request_data' => array(
			'headers' => array(
				'authorization' => 'Bearer YOUR_API_TOKEN',
			),
		),
		'example_request'      => 'https://public-api.wordpress.com/rest/v1/sites/example.wordpress.org/core',
	)
);

new Jetpack_JSON_API_Core_Modify_Endpoint(
	array(
		'description'          => 'Update WordPress installation on a Jetpack