chedule',
		'example_request_data' => array(
			'headers' => array( 'authorization' => 'Bearer YOUR_API_TOKEN' ),
			'body'    => array(
				'hook'       => 'jetpack_sync_cron',
				'arguments'  => '[]',
				'recurrence' => '1min',
				'timestamp'  => 1476385523,
			),
		),
	)
);

// POST /sites/%s/cron/unschedule
new Jetpack_JSON_API_Cron_Unschedule_Endpoint(
	array(
		'description'          => 'Unschedule one or all events with a particular hook and arguments',
		'group'                => '__do_not_document',
		'method'               => 'POST',
		'path'                 => '/sites/%s/cron/unschedule',
		'stat'                 => 'cron-unschedule',
		'path_labels'          => array(
			'$site' => '(int|string) The site ID, The site domain',
		),
		'request_format'       => array(
			'hook'      => '(string) Name of the hook that should be unscheduled',
			'timestamp' => '(int) Timestamp of the hook that you want to unschedule. This will unschedule only 1 event. (optional)',
			'arguments' => '(string) JSON Object of arguments that the hook has been scheduled with (optional)',
		),
		'response_format'      => array(
			'success' => '(bool) Was the event unscheduled?',
		),
		'example_request'      => 'https://public-api.wordpress.com/rest/v1.1/sites/