 '(float) Time in seconds before trying to sync the full sync queue again',
			'cron_size'             => '(int) Size of the current cron array',
			'next_cron'             => '(int) The number of seconds till the next item in cron.',
			'progress'              => '(array) Full Sync status by module',
			'debug_details'         => '(array) Details as to why Sync is disabled.',
		),
		'example_request'         => 'https://public-api.wordpress.com/rest/v1.1/sites/example.wordpress.org/sync/status',
	)
);

// GET /sites/%s/data-checksums
new Jetpack_JSON_API_Sync_Check_Endpoint(
	array(
		'description'             => 'Check that cacheable data on the site is in sync with wordpress.com',
		'group'                   => '__do_not_document',
		'method'                  => 'GET',
		'path'                    => '/sites/%s/data-checksums',
		'stat'                    => 'data-checksums',
		'allow_jetpack_site_auth' => true,
		'path_labels'             => array(
			'$site' => '(int|string) The site ID, The site domain',
		),
		'response_format'         => array(
			'posts'    => '(string) Posts checksum',
			'comments' => '(string) Comments checksum',
		),
		'example_request'         => 'https://public-api.wordpress.com/rest/v1.1/sites/example.wordpress.org/data-checksums',
	)
);

// GET /sites/%s/data-histogram
new Jetpack_JSON_API_Sync_Histogram_Endpoint(
	array(
		'description'             => 'Get a histogram of checksums for certain synced data',
		'group'                   => '__do_not_document',
		'method'                  => 'GET',
		'path'                    => '/sites/%s/data-histogram',
		'stat'                    => 'data-histogram',
		'allow_jetpack_site_auth' => true,
		'path_labels'             => array(
			'$site' => '(int|string) The site ID, The site domain',
		),
		'query_parameters'        => array(
			'object_type'        => '(string=posts) The type of object to checksum - posts, comments or options',
			'buckets'            => '(int=10) The number of buckets for the checksums',
			'start_id'           => '(int=0) Starting ID for the range',
			'end_id'             => '(int=null) Ending ID for the range',
			'columns'            => '(string) Columns to checksum',
			'strip_non_ascii'    => '(bool=true) Strip non-ascii characters from all columns',
			'shared_salt'        => '(string) Salt to reduce the collision and improve validation',
			'only_range_edges'   => '(bool=false) Only return the edges of the specified range',
			'detailed_drilldown' => '(bool=false) Return a detailed drilldown in `key => checksum` format',
		),
		'response_format'         => array(
			'histogram' => '(array) Associative array of histograms by ID range, e.g. "500-999" => "abcd1234"',
			'type'      => '(string) Type of checksum algorithm',
		),
		'example_request'         