pe || ! isset( $input['parent'] ) ) {
			$input['parent'] = 0;
		}

		$term = get_term_by( 'name', $input['name'], $taxonomy_type );
		if ( $term ) {
			// the same name is allowed as long as the parents are different.
			if ( $input['parent'] === $term->parent ) {
				return new WP_Error( 'duplicate', 'A taxonomy with that name already exists', 400 );
			}
		}

		$data = wp_insert_term(
			addslashes( $input['name'] ),
			$taxonomy_type,
			array(
				'description' => isset( $input['description'] ) ? addslashes( $input['description'] ) : '',
				'parent'      => $input['parent'],
			)
		);

		if ( is_wp_error( $data ) ) {
			return $data;
		}

		$taxonomy = get_term_by( 'id', $data['term_id'], $taxonomy_type );

		$return = $this->get_taxonomy( $taxonomy->slug, $taxonomy_type, $args['context'] );
		if ( ! $return || is_wp_error( $return ) ) {
			return $return;
		}

		/** This action is documented in json-endpoints/class.wpcom-json-api-site-settings-endpoint.php */
		do_action( 'wpcom_json_api_objects', 'taxonomies' );
		return $return;
	}

	/**
	 * Update a taxonomy.
	 *
	 * - /sites/%s/tags|categories/slug:%s -> $blog_id, $taxonomy_id
	 *
	 * @param string     $path API path.
	 * @param int        $blog_id Blog ID.
	 * @param int|string $object_id Term.
	 * @param string     $taxonomy_type Taxonomy type (category, post_tag).
	 */
	public function update_taxonomy( $path, $blog_id, $object_id, $taxonomy_type ) {
		$taxonomy = get_term_by( 'slug', $object_id, $taxonomy_type );
		$tax      = get_taxonomy( $taxonomy_type );
		if ( ! current_user_can( $tax->cap->edit_terms ) ) {
			return new WP_Error( 'unauthorized', 'User cannot edit taxonomy', 403 );
		}

		if ( ! $taxonomy || is_wp_error( $taxonomy ) ) {
			return new WP_Error( 'unknown_taxonomy', 'Unknown taxonomy', 404 );
		}

		if ( false === term_exists( $object_id, $taxonomy_type ) ) {
			return new WP_Error( 'unknown_taxonomy', 'That taxonomy does not exist', 404 );
		}

		$args  = $this->query_args();
		$input = $this->input( false );
		if ( ! 