 Delete if link was tmp local file
				unlink( $link );
			}

			if ( ! $this->bulk && is_wp_error( $result ) ) {
				return $result;
			}

			if ( ! $result ) {
				$error                        = __( 'An unknown error occurred during installation', 'jetpack' );
				$this->log[ $theme ]['error'] = $error;
			} elseif ( ! self::is_installed_theme( $theme ) ) {
				$error                        = __( 'There was an error installing your theme', 'jetpack' );
				$this->log[ $theme ]['error'] = $error;
			} elseif ( $upgrader ) {
				$this->log[ $theme ][] = $upgrader->skin->get_upgrade_messages();
			}
		}

		if ( ! $this->bulk && isset( $error ) ) {
			return new WP_Error( 'install_error', $error, 400 );
		}

		return true;
	}

	/**
	 * Validate the themes.
	 *
	 * @return bool|WP_Error
	 */
	protected function validate_themes() {
		if ( empty( $this->themes ) || ! is_array( $this->themes ) ) {
			return new WP_Error( 'missing_themes', __( 'No themes found.', 'jetpack' ) );
		}
		foreach ( $this->themes as $theme ) {

			if ( self::is_installed_theme( $theme ) ) {
				return new WP_Error( 'theme_already_installed', __( 'The theme is already installed', 'jetpack' ) );
			}

			/**
			 * Filters whether to skip the standard method of downloading and validating a WordPress.com
			 * theme. An 